#include "AntDef.h" 

#define SWAPMOVE(a,b,n,m,t)\
	t = (( a>>n ) ^ b ) & m;\
	b = b ^ t;\
	a = a ^ ( t<<n ); 

u64i segregate4(u64i x0)
{
	u64i	x=x0;
	u64i t;
	t = ((x >> 3) ^ x) & 0x0a0a0a0a0a0a0a0a;
	x = (x ^ t) ^ (t << 3);
	t = ((x >> 6) ^ x) & 0x00cc00cc00cc00cc;
	x = (x ^ t) ^ (t << 6);  
	t = ((x >> 12) ^ x) & 0x0000f0f00000f0f0;
	x = (x ^ t) ^ (t << 12); 
	t= ((x<<24)&0x00ff00ff00000000) | ((x>>24)&0x00000000ff00ff00);
	return (x&0xff00ff0000ff00ff)|t; 
}    

static void bs16(u16i *l,u16i *r)  
{ 
	u64i T; 
	u64i L= *((u64i *)l);
	u64i R= *((u64i *)r); 
	u64i A = (L&0x00000000FFFFFFFF)|(R<<32);  //0 1  45 
	u64i B=  (R&0xFFFFFFFF00000000)|(L>>32);  //2 3 6 7
	SWAPMOVE(A,B,1,0x5555555555555555,T);
	L= (A&0x0000FFFF0000FFFF)|((B&0x0000FFFF0000FFFF)<<16);   //0 2 46 
	R= (B&0xFFFF0000FFFF0000)|((A&0xFFFF0000FFFF0000)>>16);   //1 3  5 7 
	SWAPMOVE(L,R,1,0x5555555555555555,T);
	SWAPMOVE(L,R,2,0x3333333333333333,T);

	A= (L&0x0000FFFF0000FFFF)|((R&0x0000FFFF0000FFFF)<<16);   //0 1 4 5 
	B= (R&0xFFFF0000FFFF0000)|((L&0xFFFF0000FFFF0000)>>16);   //2 3 6 7 	
	SWAPMOVE(A,B,4,0x0f0f0f0f0f0f0f0f,T);
	*((u64i *)l)= A;
	*((u64i *)r)= B;   

}


void vbitSlicing128(u8i *outA, u16i *l,u16i *r )
{
	__m128i tm;
	bs16( l, r); 
	tm=_mm_loadu_si128((__m128i*)l);
	tm=_mm_shuffle_epi8(tm,_mm_setr_epi8(0, 2, 8, 10, 1, 3, 9, 11, 4, 6, 12, 14, 5, 7, 13, 15) );
	_mm_storeu_si128((__m128i*)(outA),tm); 
	
}


void AntBitSlicing128( u16i *l,u16i *r,const u8i *pt)
{  
	__m128i m=_mm_loadu_si128((__m128i*)pt); 
	u64i *p=(u64i *)(&m);
	 u64i L0 = (*(p+1)  );
	 u64i R0 =  (*(p)  );
	
	p= (u64i *)(l);	 
	*p = segregate4(L0 );
	p=(u64i *)(r);
	*p= segregate4(R0 ); 
}


