#include "Ant128256.h" 
#include "Ant128256_coreD.h"
#include "Ant128256_coreE.h"

#define t0_128 7
#define t1_128 1

#define CSYFunA_128(  x)\
	m= x[0]^ROTL8(x[7],t1_128); \
	n= x[1] ^ROTL8( m ,t1_128);\
	t0= x[2]<<t0_128;\
	t1= x[3]<<t0_128;\
	t2= x[4]<<t0_128; \
	x[1]=x[4];\
	x[4]=x[7]^(t1);\
	x[7]= x[2]^ROTL8(n,t1_128);	\
	x[2]= x[5];\
	x[5]= m^(t2) ;\
	x[0]= x[3];\
	x[3]= x[6]^(t0);\
	x[6]= n;    	


#define CSYBsRK_128(rk,m,x0)\
	t  = x0; \
	* ((u64i*)(rk+m*8))= (t );


#define CSYRoundFun_128(l,r,i) \
		memcpy(&m, rk+i,8);\
		m= segregate4(m);\
		memcpy(trk,&m,8);\
    x0= ROTL16(l[0],15);  \
	y0=ROTL16( (x0 &l[3])^l[1],1) ;\
	x1=ROTL16((l[2]&l[3])^l[1],11) ;\
	a0=ROTL16(l[2],8);\
	a1=ROTL16(l[0],4);\
	y1=ROTL16(l[3],15)^ROTL16(l[2],2);\
	y1^=(y0&a0);\
	r[0]^=y1^trk[0];\
	y1=ROTL16(l[3],3)^(x1&a1);\
	r[1]^=x0^y1^trk[1];\
	r[2]^=y0^a1^trk[2];\
	r[3]^=a0^x1^trk[3];


static void CSYGenRK_128_256(u8i * Rk , u8i *MK ); 
static void EncCSY_128_256_Round(u8i *out,u8i *pt,  u8i *rk,int round);
 
//ֻּӽ
//ӽԿ洢ռ䲻ͬ 
void Key_Schedule(unsigned char *Seedkey, int KeyLen, unsigned   char Direction, unsigned char *Subkey)
{
	if (Direction == Dirt_ENC)
		AntGenRK_128_256_ENC(Subkey, Seedkey);
	else
		AntGenRK_128_256_DEC((__m256i *)Subkey, Seedkey);
}


int Crypt_Enc_Block(unsigned char *input,int in_len, unsigned char  *output, int *out_len, unsigned char *key , int keylen)
{
	u32i _C_ALIGN32(rk[RoundANT128256 * 2]);

	int i;
	if (in_len % 16)
		return -1;
	if (keylen != 32)
		return -2;
	AntGenRK_128_256_ENC((u8i *)rk, key);
	for (i = 0; i < in_len; i += 16)
		Ant128256EncDataS(output + i, input + i, (u8i *)rk);
	*out_len = in_len;
	return 0;
}


int Crypt_Dec_Block(unsigned char *input,int in_len, unsigned char  *output, int *out_len, unsigned char *key , int keylen)
{
	u8i _C_ALIGN32(TText[256]);
	__m256i rksimd[RoundANT128256 * 4];
	int  leftbytes;
	if (in_len < 1)
		return -1;
	if (in_len & 0x0f)
		return -2;
	if (keylen != 32)
		return -3;
	AntGenRK_128_256_DEC(rksimd, key);
	leftbytes = in_len;
	while (leftbytes >= 256)
	{
		Ant128256DecDataM(output, input, (u8i *)rksimd);
		output += 256;
		input += 256;
		leftbytes -= 256;
	}
	if (leftbytes)
	{
		memcpy(TText, input, leftbytes);
		Ant128256DecDataM(TText, TText, (u8i *)rksimd);
		memcpy(output, TText, leftbytes);
	}
	*out_len = in_len;
	return 0;
}


//IV ȫ 0

int Crypt_Enc_Block_CBC(unsigned char *input, int in_len, unsigned char  *output, int *out_len, unsigned char *key, int keylen)
{
	u8i _C_ALIGN32(rk[RoundANT128256 * 8]);
	u64i _C_ALIGN16(IV[2]);
	int i;
	if (in_len < 1)
		return -1;
	if (in_len & 0x0f)
		return -2;
	if (keylen != 32)
		return -3;
	AntGenRK_128_256_ENC(rk, key);
	Ant128256EncDataS(output, input, rk);
	for (i = 16; i < in_len; i += 16)
	{
		IV[0] = (*(u64i *)(input + i)) ^ (*(u64i *)(output + i - 16));
		IV[1] = (*(u64i *)(input + i + 8)) ^ (*(u64i *)(output + i - 8));
		Ant128256EncDataS(output + i, (u8i *)IV, rk);
	}
	*out_len = in_len;
	return 0;
}
int Crypt_Dec_Block_CBC(unsigned char *input, int in_len, unsigned char  *output, int *out_len, unsigned char *key, int keylen)
{
	u8i _C_ALIGN32(TText[256]);
	__m256i rksimd[RoundANT128256 * 4];
	__m128i mIV = _mm_set1_epi64x(0);
	int  leftbytes;
	if (in_len < 1)
		return -1;
	if (in_len & 0x0f)
		return -2;
	if (keylen != 32)
		return -3;
	AntGenRK_128_256_DEC(rksimd, key);
	leftbytes = in_len;
	while (leftbytes >= 256)
	{
		Ant128256DecDataM_CBC(output, input, (u8i *)rksimd, &mIV);
		output += 256;
		input += 256;
		leftbytes -= 256;
	}
	if (leftbytes)
	{
		memcpy(TText, input, leftbytes);
		Ant128256DecDataM_CBC(TText, TText, (u8i *)rksimd, &mIV);
		memcpy(output, TText, leftbytes);
	}
	*out_len = in_len;
	return 0;
}

int Crypt_Enc_Block_Round(unsigned char *input,int in_len,  unsigned char *output, int *out_len, unsigned char *key, int keylen, int CryptRound)
{
	int i;
	u8i   rk[2048]  ={0x00, 0x01, 0x02, 0x03,0x04, 0x05, 0x06,0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F}; 
	if(in_len<1)
		return -1;
	if(keylen!=32)
		return -2;
	if((CryptRound> RoundANT128256) || (CryptRound<0))
		return -3;
	CSYGenRK_128_256(rk, key);
		for(  i=0;i<in_len;i+=16)
	EncCSY_128_256_Round(output+i, input+i, rk,  CryptRound);
	*out_len= in_len;
	printf(" round   %03d : ",CryptRound);
	for(i=0;i<16;i++)
	{
		printf("%02X", output[15-i]);
		if(i==7) 
			printf(" ");
	}
	printf(" rk%03d : ",CryptRound);
		for(i=0;i<8;i++)
      printf("%02X", rk[CryptRound*8-i-1]);
	printf("\n");
	 
	return 0;
}

static void CSYGenRK_128_256(u8i * rk, u8i *MK )
{
	u64i x0  ;	 
	u64i x1   ;
	u64i x2   ; 
	u64i x3  ;  
	u64i t ;
	u64i i;
	u8i m,n, t0,t1,t2;
	u8i *p=(u8i *)(&x3); 
	x3=(* ((u64i*)(MK+24)));
	x2=(* ((u64i*)(MK+16)));
	x1=(* ((u64i*)(MK+8))); 
	x0=(* ((u64i*)(MK)));
	for( i=0;i< RoundANT128256 -4;i++)
	{ 
		CSYBsRK_128(rk,i,x0);
		x0=x1;
		x1=x2;
		x2=x3; 
		CSYFunA_128(p);
		x3^= t;
		x3^= x0;	
		x3 ^=(i+1); 
	}	  
	CSYBsRK_128(rk,i,x0);
	i++;
	CSYBsRK_128(rk,i,x1); 
	i++;
	CSYBsRK_128(rk,i,x2); 
	i++;
	CSYBsRK_128(rk,i,x3);  
} 

 

static void EncCSY_128_256_Round(u8i *out,u8i *pt,  u8i *rk,int round)
{ 
	u16i l[8];
	u16i x0,x1; 
	u16i y0,y1;  
	u16i a0,a1;
	int i; 
	u16i trk[4];
	u64i m;
	u16i *r=l+4;  
	u64i *p;
	AntBitSlicing128(  l, r, pt) ; 
	for( i=0;i<round;i++)
	{        
		if(i%2==0)
		{
			CSYRoundFun_128(l,r,8*i ) ;

		}
		else
		{
			CSYRoundFun_128(r,l,8*i ) ;  
		}
	}  
	vbitSlicing128(out,l,r); 

	if(round%2)
	{
		u8i tn[8];
		memcpy(tn, out, 8);
		memcpy(out,out+8,8);
		memcpy(out+8,tn,8); 
	} 	
	p= (u64i *)out;
	*p= (*p); p++;
	*p= (*p);
}