#include "Ant128256_coreE.h" 

#include "Ant128256.h" 

#define t0_128 7
#define t1_128 1


#define CSYFunA_128(  x)\
	m= x[0]^ROTL8(x[7],t1_128); \
	n= x[1] ^ROTL8( m ,t1_128);\
	t0= x[2]<<t0_128;\
	t1= x[3]<<t0_128;\
	t2= x[4]<<t0_128; \
	x[1]=x[4];\
	x[4]=x[7]^(t1);\
	x[7]= x[2]^ROTL8(n,t1_128);	\
	x[2]= x[5];\
	x[5]= m^(t2) ;\
	x[0]= x[3];\
	x[3]= x[6]^(t0);\
	x[6]= n;    	


#define CSYBsRK_128(rk,m,x0)\
	t  = x0; \
	* ((u64i*)(rk+m*8))= segregate4(t ); 


#define CSYRoundFun_128(l,r,i) \
	x0= ROTL16(l[0],15);  \
	y0=ROTL16( (x0 &l[3])^l[1],1) ;\
	x1=ROTL16((l[2]&l[3])^l[1],11) ;\
	a0=ROTL16(l[2],8);\
	a1=ROTL16(l[0],4);\
	y1=ROTL16(l[3],15)^ROTL16(l[2],2);\
	y1^=(y0&a0);\
	r[0]^=y1^trk[i+0];\
	y1=ROTL16(l[3],3)^(x1&a1);\
	r[1]^=x0^y1^trk[i+1];\
	r[2]^=y0^a1^trk[i+2];\
	r[3]^=a0^x1^trk[i+3];


 void AntGenRK_128_256_ENC(u8i * rk, u8i *MK)
{
	u64i x0;
	u64i x1;
	u64i x2;
	u64i x3;
	u64i t;
	u64i i;
	u8i m, n, t0, t1, t2;
	u8i *p = (u8i *)(&x3);
	x3 = (*((u64i*)(MK + 24)));
	x2 = (*((u64i*)(MK + 16)));
	x1 = (*((u64i*)(MK + 8)));
	x0 = (*((u64i*)(MK))); 

		for (i = 0; i < RoundANT128256 - 4; i++)
		{
			CSYBsRK_128(rk, i, x0);
			x0 = x1;
			x1 = x2;
			x2 = x3;
			CSYFunA_128(p);
			x3 ^= t;
			x3 ^= x0;
			x3 ^= (i + 1);
		}
		CSYBsRK_128(rk, i, x0);
		i++;
		CSYBsRK_128(rk, i, x1);
		i++;
		CSYBsRK_128(rk, i, x2);
		i++;
		CSYBsRK_128(rk, i, x3);
	 
}
 

void Ant128256EncDataS(u8i *out, u8i *pt, u8i *rk)
{
	u16i l[8];
	u16i x0, x1;
	u16i y0, y1;
	u16i a0, a1;
	int i;
	u16i *trk = (u16i *)rk;
	u16i *r = l + 4;

	AntBitSlicing128(l, r, pt);
	for (i = 0; i < RoundANT128256 / 2; i++)
	{
		CSYRoundFun_128(l, r, 8 * i);
		CSYRoundFun_128(r, l, 8 * i + 4);
	} 
	vbitSlicing128(out, l, r); 
}
 