﻿#include "Ant256256.h"  
#include "Ant256256_coreE.h"  
#include "Ant256256_coreD.h"  

#define t0_128 15
#define t1_128 1

#define CSYFunA_256(  x,i)\
	m= x[0]^ROTL16(x[7],t1_128); \
	n= x[1] ^ROTL16( m ,t1_128);\
	t0= x[2]<<t0_128;\
	t1= x[3]<<t0_128;\
	t2= x[4]<<t0_128; \
	x[1]=x[4];\
	x[4]=x[7]^(t1);\
	x[7]= x[2]^ROTL16(n,t1_128);\
	x[2]= x[5];\
	x[5]= m^(t2) ;\
	x[0]= x[3]^(i);\
	x[3]= x[6]^(t0);\
	x[6]= n;     
 
 #define CSYBsRK_256(rk,m,x0_0,x0_1)\
 	t_0  = x0_0; \
	t_1=x0_1;\
	* ((u64i*)(rk+m*16+8)) =  (t_1); \
	* ((u64i*)(rk+m*16))=  (t_0 ); 

#define CSYRoundFun_256(l,r,i,A2,A3,B2,B3,a0,t0) \
		memcpy(&m, rk+i+8,8);\
		m= segregate4(m);\
		memcpy(M,&m,8);\
		memcpy(&m, rk+i,8);\
		m= segregate4(m);\
		memcpy(M+1,&m,8);\
	_mm_storeu_si128((__m128i*)(trk ),  _mm_shuffle_epi8( _mm_loadu_si128((__m128i*)(M)), MSK));  \
	t0= ROTL32(l[0],31);\
	A2= ROTL32((t0&l[3])^ l[1],1);\
	A3= ROTL32(l[2],16);\
	B2= ROTL32(l[0],4);\
	a0= ROTL32(l[3],31);\
	B3= ROTL32((l[3]&l[2])^l[1], 19);\
	t0^= (B2&B3)^ROTL32(l[3],3);\
	a0^= (A2&A3);\
	A3^=B3;\
	A2^=B2;\
	a0^=ROTL32(l[2],2);\
	\
	r[0]^=a0^trk[0];\
	r[1]^=t0^trk[1];\
	r[2]^=A2^trk[2];\
	r[3]^=A3^trk[3]; 

static void CSYGenRK_256_256(u8i * Rk , u8i *MK ); 
static void EncCSY_256_256_Round(u8i *out,u8i *pt,  u8i *rk,int round);

//只适用整轮加解密
//加解密轮密钥存储空间不同 
void Key_Schedule(unsigned char *Seedkey, int KeyLen, unsigned   char Direction, unsigned char *Subkey)
{
	if (Direction == Dirt_ENC)
		AntGenRK_256_256_ENC(Subkey, Seedkey);
	else
		AntGenRK_256_256_DEC((__m128i *)Subkey, Seedkey);
}

int Crypt_Enc_Block(unsigned char *input,int in_len, unsigned char  *output, int *out_len, unsigned char *key , int keylen)
{
	u64i _C_ALIGN32(rk[RoundANT256256 * 2]);

	int i;
	if (in_len % 32)
		return -1;
	if (keylen != 32)
		return -2;
	AntGenRK_256_256_ENC((u8i *)rk, key);
	for (i = 0; i < in_len; i += 32)
		Ant256256EncDataS(output + i, input + i, (u8i *)rk);
	*out_len = in_len;
	return 0;
}
int Crypt_Dec_Block(unsigned char *input,int in_len, unsigned char  *output, int *out_len, unsigned char *key , int keylen)
{
	u8i _C_ALIGN32(TText[256]);
	__m256i rksimd[RoundANT256256 * 4];
	int   leftbytes;
	if (in_len < 1)
		return -1;
	if (in_len %32)
		return -2;
	if (keylen != 32)
		return -3;
	AntGenRK_256_256_DEC((__m128i *)rksimd, key);
	leftbytes = in_len;
	while (leftbytes >= 256)
	{
		Ant256256DecDataM(output, input, (u8i *)rksimd);
		output += 256;
		input += 256;
		leftbytes -= 256;
	}
	if (leftbytes)
	{
		memcpy(TText, input, leftbytes);
		Ant256256DecDataM(TText, TText, (u8i *)rksimd);
		memcpy(output, TText, leftbytes);
	}
	*out_len = in_len;
	return 0;
}




//IV ȫ 0

int Crypt_Enc_Block_CBC(unsigned char *input, int in_len, unsigned char  *output, int *out_len, unsigned char *key, int keylen)
{
	u64i _C_ALIGN32(rk[RoundANT256256 * 2]);
	__m256i IV;
	int i ;
	if (in_len < 1)
		return -1;
	if (in_len %32)
		return -2;
	if (keylen != 32)
		return -3;
	AntGenRK_256_256_ENC((u8i *)rk, key);
	Ant256256EncDataS(output, input, (u8i *)rk);
	for (i = 32; i < in_len; i += 32)
	{
		IV = _mm256_xor_si256(_mm256_loadu_si256((__m256i *)(input + i)), _mm256_loadu_si256((__m256i *)(output + i - 32)));
		Ant256256EncDataS(output + i,(u8i *)( &IV), (u8i *)rk);
	}
	*out_len = in_len;
	return 0;
}
int Crypt_Dec_Block_CBC(unsigned char *input, int in_len, unsigned char  *output, int *out_len, unsigned char *key, int keylen)
{
	u8i _C_ALIGN32(TText[256]);
	__m256i rksimd[RoundANT256256 * 4];
	__m256i mIV = _mm256_set1_epi64x(0);
	int  leftbytes;
	if (in_len < 1)
		return -1;
	if (in_len % 32)
		return -2;
	if (keylen != 32)
		return -3;
	AntGenRK_256_256_DEC((__m128i *)rksimd, key);
	leftbytes = in_len;
	while (leftbytes >= 256)
	{
		Ant256256DecDataM_CBC(output, input, (u8i *)rksimd, &mIV);
		output += 256;
		input += 256;
		leftbytes -= 256;
	}
	if (leftbytes)
	{
		memcpy(TText, input, leftbytes);
		Ant256256DecDataM_CBC(TText, TText, (u8i *)rksimd, &mIV);
		memcpy(output, TText, leftbytes);
	}
	*out_len = in_len;
	return 0;
}


int Crypt_Enc_Block_Round(unsigned char *input,int in_len,  unsigned char *output, int *out_len, unsigned char *key, int keylen, int CryptRound)
{
	int i;
	u8i  _C_ALIGN16( rk[2048])  ={0x00, 0x01, 0x02, 0x03,0x04, 0x05, 0x06,0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F}; 
	u8i  _C_ALIGN16( keystd[2048])  ={0x00, 0x01, 0x02, 0x03,0x04, 0x05, 0x06,0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F}; 

	if(in_len<1)
		return -1;
	if(keylen!=32)
		return -2;
	if((CryptRound> RoundANT256256) || (CryptRound<0))
		return -3;
	CSYGenRK_256_256(rk,key );
		for(  i=0;i<in_len;i+=32)
	EncCSY_256_256_Round(output+i, input+i, rk,  CryptRound);
	*out_len= in_len;
	printf(" round   %03d : ",CryptRound);
	for(i=0;i<32;i++)
	{  
	  if(i%8==0  ) 
	   printf(" ");
	  printf("%02X", output[31-i]);
	};
	printf("   rk%03d : ",CryptRound);
	for( i=0;i<16;i++)
	{
      if( i==8) 
	     printf(" "); 
		printf("%02X", rk[CryptRound*16-i-1]);
	}
	printf("\n");
	return 0;
}


static void CSYGenRK_256_256(u8i * rk, u8i *MK )
{
	u64i x0_0,x0_1 ;	 
	u16i x1[8] ; 
	u64i t_0,t_1 ;
	u16i i;
	u16i m,n, t0,t1,t2;
	x0_0=(* ((u64i*)(MK)));
	x0_1=(* ((u64i*)(MK+8 )));
	* ((u64i*)x1)=(* ((u64i*)(MK+16))); 
	* ((u64i*)(x1+4))=(* ((u64i*)(MK+24)));
	for(  i=0;i< RoundANT256256 -2;i++)
	{ 
		CSYBsRK_256(rk,i,x0_0,x0_1); 
		x0_0=* ((u64i*)x1);
		x0_1=* ((u64i*)(x1+4));  
		CSYFunA_256(x1,i+1);
		* ((u64i*)x1)^=t_0;
		* ((u64i*)(x1+4))^=t_1; 
	}	  
	CSYBsRK_256(rk,i,x0_0,x0_1); 
	i++;
	CSYBsRK_256(rk,i,(*((u64i *)(x1))),(* ((u64i*)(x1+4))));  
} 
 

void EncCSY_256_256_Round(u8i *out,u8i *pt,  u8i *rk,int round)
{	    
	u32i l[8]; 		
	u32i x0,x1; 
	u32i y0,y1;  
	u32i a0,a1; 
	u32i trk[4];  
	u64i M[2];
	   const __m128i MSK= _mm_setr_epi8(8,9,0,1,10,11,2,3,12,13,4,5,14,15,6,7);
	u64i m; 
	u32i *r=l+4;
	int i;  	
	//载入数据并位切片
	AntBitSlicing256(l,r,pt);

	for( i=0;i<round ;i++)
	{       
		if(i%2==0)
		{
			CSYRoundFun_256(l,r,16*i,a0,a1,y0,y1,x0,x1 ) ;

		}
		else
		{
			CSYRoundFun_256(r,l,16*i,a0,a1,y0,y1,x0,x1 ) ;  
		}
	} 
	//位切片恢复，数据输出 
	vbitSlicing256(out,l,r); 

	if(round%2)
	{
		u8i tn[16];
		memcpy(tn, out, 16);
		memcpy(out,out+16,16);
		memcpy(out+16,tn,16); 
	}  
} 