#include "Ant256256_coreE.h" 
#define t0_128 15
#define t1_128 1

#define CSYFunA_256(  x,i)\
	m= x[0]^ROTL16(x[7],t1_128); \
	n= x[1] ^ROTL16( m ,t1_128);\
	t0= x[2]<<t0_128;\
	t1= x[3]<<t0_128;\
	t2= x[4]<<t0_128; \
	x[1]=x[4];\
	x[4]=x[7]^(t1);\
	x[7]= x[2]^ROTL16(n,t1_128);\
	x[2]= x[5];\
	x[5]= m^(t2) ;\
	x[0]= x[3]^(i);\
	x[3]= x[6]^(t0);\
	x[6]= n;    


#define CSYBsRK_256(rk,m,x0_0,x0_1)\
	t_0  = x0_0; \
	t_1=x0_1;\
	* ((u64i*)(rk+m*16)) = segregate4(t_1); \
	* ((u64i*)(rk+m*16+8))= segregate4(t_0 );\
	_mm_storeu_si128((__m128i*)(rk+m*16 ),  _mm_shuffle_epi8( _mm_loadu_si128((__m128i*)(rk+m*16)), MSK));   

#define CSYRoundFun_256(l,r,i,A2,A3,B2,B3,a0,t0) \
	t0= ROTL32(l[0],31);\
	A2= ROTL32((t0&l[3])^ l[1],1);\
	A3= ROTL32(l[2],16);\
	B2= ROTL32(l[0],4);\
	a0= ROTL32(l[3],31);\
	B3= ROTL32((l[3]&l[2])^l[1], 19);\
	t0^= (B2&B3)^ROTL32(l[3],3);\
	a0^= (A2&A3);\
	A3^=B3;\
	A2^=B2;\
	a0^=ROTL32(l[2],2);\
	\
	r[0]^=a0^trk[i+0];\
	r[1]^=t0^trk[i+1];\
	r[2]^=A2^trk[i+2];\
	r[3]^=A3^trk[i+3]; 


 void AntGenRK_256_256_ENC(u8i * rk, u8i *MK)
{
	u64i x0_0, x0_1;
	u16i x1[8];
	u64i t_0, t_1;
	u16i i;
	u16i m, n, t0, t1, t2;
	const __m128i MSK = _mm_setr_epi8(8, 9, 0, 1, 10, 11, 2, 3, 12, 13, 4, 5, 14, 15, 6, 7);
	x0_0 = (*((u64i*)(MK)));
	x0_1 = (*((u64i*)(MK + 8)));
	*((u64i*)x1) = (*((u64i*)(MK + 16)));
	*((u64i*)(x1 + 4)) = (*((u64i*)(MK + 24)));
	 
		for (i = 0; i < RoundANT256256 - 2; i++)
		{
			CSYBsRK_256(rk, i, x0_0, x0_1);
			x0_0 = *((u64i*)x1);
			x0_1 = *((u64i*)(x1 + 4));
			CSYFunA_256(x1, i + 1);
			*((u64i*)x1) ^= t_0;
			*((u64i*)(x1 + 4)) ^= t_1;
		}
		CSYBsRK_256(rk, i, x0_0, x0_1);
		i++;
		CSYBsRK_256(rk, i, (*((u64i *)(x1))), (*((u64i*)(x1 + 4)))); 
}
 

void Ant256256EncDataS(u8i *out, u8i *pt, u8i *rk)
{
	u32i l[8];
	u32i x0, x1;
	u32i y0, y1;
	u32i a0, a1;
	u32i *trk = (u32i *)rk;
	u32i *r = l + 4;
	int i;
	AntBitSlicing256(l, r, pt);

	for (i = 0; i < RoundANT256256 / 2; i++)
	{
		CSYRoundFun_256(l, r, 8 * i, a0, a1, y0, y1, x0, x1);
		CSYRoundFun_256(r, l, 8 * i + 4, a0, a1, y0, y1, x0, x1);
	}
	vbitSlicing256(out, l, r);
}
 