#include "AntDef.h" 

#define SWAPMOVE(a,b,n,m,t)\
	t = (( a>>n ) ^ b ) & m;\
	b = b ^ t;\
	a = a ^ ( t<<n ); 


u64i segregate4(u64i x0)
{
	u64i	x=x0;
	u64i t;
	t = ((x >> 3) ^ x) & 0x0a0a0a0a0a0a0a0a;
	x = (x ^ t) ^ (t << 3);
	t = ((x >> 6) ^ x) & 0x00cc00cc00cc00cc;
	x = (x ^ t) ^ (t << 6);  
	t = ((x >> 12) ^ x) & 0x0000f0f00000f0f0;
	x = (x ^ t) ^ (t << 12); 
	t= ((x<<24)&0x00ff00ff00000000) | ((x>>24)&0x00000000ff00ff00);
	return (x&0xff00ff0000ff00ff)|t; 
}   

#define SWAPMOVE32_SIMD(a,b,n,m,t)\
	t=_mm_xor_si128( _mm_srli_epi32(a,n), b);\
	t= _mm_and_si128(m,t );\
	b= _mm_xor_si128(b,t);\
	t=  _mm_slli_epi32(t,n);\
	a=_mm_xor_si128(a,t); 

static void bs16(u16i *l,u16i *r)  
{ 
	u64i T; 
	u64i L= *((u64i *)l);
	u64i R= *((u64i *)r); 
	u64i A = (L&0x00000000FFFFFFFF)|(R<<32);  //0 1  45 
	u64i B=  (R&0xFFFFFFFF00000000)|(L>>32);  //2 3 6 7
	SWAPMOVE(A,B,1,0x5555555555555555,T);
	L= (A&0x0000FFFF0000FFFF)|((B&0x0000FFFF0000FFFF)<<16);   //0 2 46 
	R= (B&0xFFFF0000FFFF0000)|((A&0xFFFF0000FFFF0000)>>16);   //1 3  5 7 
	SWAPMOVE(L,R,1,0x5555555555555555,T);
	SWAPMOVE(L,R,2,0x3333333333333333,T);

	A= (L&0x0000FFFF0000FFFF)|((R&0x0000FFFF0000FFFF)<<16);   //0 1 4 5 
	B= (R&0xFFFF0000FFFF0000)|((L&0xFFFF0000FFFF0000)>>16);   //2 3 6 7 	
	SWAPMOVE(A,B,4,0x0f0f0f0f0f0f0f0f,T);
	*((u64i *)l)= A;
	*((u64i *)r)= B;   

}

static  void bs32(u32i *l,u32i *r)
{ 
	__m128i L=_mm_loadu_si128((__m128i*) l ); 
	__m128i R=_mm_loadu_si128((__m128i*) r );
	__m128i T;
	__m128i Lb0 = _mm_set1_epi32(0x55555555)  ;
	__m128i Lb1 = _mm_set1_epi32(0x33333333)  ;  
	__m128i Lb2 = _mm_set1_epi32(0x0f0f0f0f)  ;    	
	__m128i A= _mm_unpacklo_epi64(L,R);  // 0 1 4 5
	__m128i B= _mm_unpackhi_epi64(L,R);  // 2 3 6 7
	SWAPMOVE32_SIMD(A,B, 1, Lb0,T);
	L= _mm_unpacklo_epi32(A,B);  // 0 2 1 3
	R= _mm_unpackhi_epi32(A,B);   // 4 6  5 7
	A= _mm_unpacklo_epi64(L,R);  // 0 2 4 6 
	B= _mm_unpackhi_epi64(L,R);  // 1 3  5 7

	SWAPMOVE32_SIMD(A,B, 1, Lb0,T);
	SWAPMOVE32_SIMD(A,B, 2, Lb1,T);     
	L= _mm_unpacklo_epi32(A,B);  // 0 1 2 3
	R= _mm_unpackhi_epi32(A,B);  //  4 5 6  7
	A= _mm_unpacklo_epi64(L,R);  // 0 1  4 5
	B= _mm_unpackhi_epi64(L,R);  // 2 3  6  7

	SWAPMOVE32_SIMD(A,B, 4, Lb2,T);  
	L= _mm_unpacklo_epi64(A,B);  // 0 1 2 3
	R= _mm_unpackhi_epi64(A,B);  // 4 5  6 7  
	_mm_storeu_si128((__m128i*)(l  ), L);
	_mm_storeu_si128((__m128i*)(r  ), R);    
}



void vbitSlicing256(u8i *outA, u32i *l,u32i *r )
{
	bs32(l,r);
	_mm256_storeu_si256((__m256i*)(outA), \
		_mm256_shuffle_epi8(_mm256_loadu_si256((__m256i*)l), \
			_mm256_setr_epi8(0, 4, 8, 12, 1, 5, 9, 13, 2, 6, 10, 14, 3, 7, 11, 15, 0, 4, 8, 12, 1, 5, 9, 13, 2, 6, 10, 14, 3, 7, 11, 15)));
} 



void AntBitSlicing256( u32i *l,u32i *r,const u8i *pt) 
{    __m128i MSK;
__m128i m128d ;
u64i L0 = (*((u64i *)(pt+24))  );
u64i L1 = (*((u64i *)(pt+16)) );
u64i R0 = (*((u64i *)(pt+8)) );
u64i R1 = (*((u64i *)(pt+0)) );  
u64i *p= (u64i *)(l);	 
*p = segregate4(L0);
p= (u64i *)(l+2);	 
*p = segregate4(L1 );
p=(u64i *)(r);
*p= segregate4(R0);
p=(u64i *)(r+2);
*p= segregate4(R1 ); 
MSK= _mm_setr_epi8(8,9,0,1,10,11,2,3,12,13,4,5,14,15,6,7);
m128d= _mm_shuffle_epi8( _mm_loadu_si128((__m128i*)l), MSK) ; 
_mm_storeu_si128((__m128i*)(l), m128d);
m128d= _mm_shuffle_epi8( _mm_loadu_si128((__m128i*)r), MSK) ;
_mm_storeu_si128((__m128i*)(r), m128d);

}
 