#ifndef _H_ANTCRYTYPE_
#define _H_ANTCRYTYPE_

#include <stdint.h> 
#include <stdio.h> 
#include <intrin.h>
#ifdef  __GNUC__
   #include <immintrin.h>
 #elif _MSC_VER 
   #include <smmintrin.h>
 #endif 
 
#define RoundANT256256 74
 
#define Dirt_ENC 0
#define Dirt_DEC 1
 
 

 #ifndef u8i
   #define u8i unsigned char
#endif

#ifndef u16i
   #define u16i uint16_t
#endif

#ifndef u32i
   #define u32i uint32_t 
#endif

#ifndef u64i
   #define u64i  uint64_t
#endif

#ifndef u128i   
   #define u128i __m128i  
#endif


#ifdef  __GNUC__
   #define _C_ALIGN(n, A)  A __attribute__ ((aligned (n)))
#elif _MSC_VER 
   #define _C_ALIGN(n, A)  __declspec( align(n) ) A
#endif

#define _C_ALIGN16(A) _C_ALIGN(16,A)
#define _C_ALIGN32(A) _C_ALIGN(32,A) 


/******************************
 swap   rotate 
********************************/
#define ROTL4(v, n) \
  (((v) << (n)) | ((v) >> (4 - (n)))) 
  
#define ROTL8(v, n) \
  ((u8i)((v) << (n)) | ((v) >> (8 - (n)))) 
  
#define ROTL16(v, n) \
  ((u16i)((v) << (n)) | ((v) >> (16 - (n)))) 
  
#define ROTR16(v, n) \
  ((u16i)((v) >> (n)) | ((v) << (16 - (n))))   
  
#define SWAP16(v)\
 ROTL16(v, 8)
 
#define ROTL32(v, n) \
  ((u32i)((v) << (n)) | ((v) >> (32 - (n))))
  
 #define ROTR32(v, n) \
  ((u32i)((v) >> (n)) | ((v) <<(32 - (n))))
  
#define SWAP32(v) \
  ((ROTL32(v,  8) & (u32i)(0x00FF00FF)) | \
   (ROTL32(v, 24) & (u32i)(0xFF00FF00))) 
 
#define SWAP64(v) \
  (((u64i)SWAP32((u32i)(v)) << 32) | (u64i)SWAP32((u32i)(v >> 32)))
  
 
#define ROTL64(v, n) \
  ((u64i)((v) << (n)) | ((v) >> (64 - (n))))

u64i segregate4(u64i x0); 
  void AntBitSlicing256( u32i *l,u32i *r,const u8i *pt);
   
 void vbitSlicing256(u8i *outA, u32i *l,u32i *r );
  
 

#endif  //_H_ANTCRYTYPE_
